from PIL import Image, ImageTk, ImageStat, ImageChops, ImageOps;
from Tkinter import *;
import ImageCalibration;

#camera, calibration 
def new(cam, cal, gai):
    return WebcamUI(cam, cal, gai);

class WebcamUI:

    def __init__(self, cam, cal, getAnnotatedImage):
        self.cam = cam;
        self.running=False;
	self.live = False;
	self.imageCalibration = cal;
	self.getAnnotatedImage = getAnnotatedImage;
	self.shouldTrack = False; 
	self.tracking = False;
	self.targetWidth = 50;
	self.targetHeight= 50;
   
    def setTargetWidth(self, width):
        self.targetWidth = float(width);
	print "targetWidth: " + str(self.targetWidth);

    def setTargetHeight(self, height):
        self.targetHeight = float(height);
	print "targetHeight: " + str(self.targetHeight);

    def windowClosed(self, event):
        self.running=False;  

    def doDifferences(self):
        #handler from when button is clicked to detect differences
	#between to base images.
	#fill this in this weekend, and refactor to its own class.
	# old --
	# self.imageCalibration.calculateDifferenceDistribution("Calibration Image: 1", "Calibration Image: 2");
	self.shouldTrack = True;
	return;

    def start(self, count):
        if (not self.running):
            self.running = True;
            tk=Toplevel(); #assume the toolkit is created elsewhere
	    tk.bind("<Destroy>", self.windowClosed);
	    imageFrame = Frame(tk);
	    bestLabel = Label(tk, text="PLACEHOLDER");
	    doDiffButton = Button(tk, text="Do Differences", command=self.doDifferences);
            self.photos = list();
            self.photos.append(PhotoUI(imageFrame, "Calibration Image", self.cam, self.imageCalibration, True));
            self.photos.append(PhotoUI(imageFrame, "Differnce Map", self.cam, self.imageCalibration));
	    #self.live = LiveUI(imageFrame, "Live Image", self.cam, self.imageCalibration, bestLabel);
	    self.trackLabel = Label(tk, image="");
	    imageFrame.pack();
	    bestLabel.pack();
	    doDiffButton.pack();
	    self.trackLabel.pack();
            #tk.mainloop();
            self.l=0
            running=False;
        else:
            print("Already started");

             
    def onClock(self, time):
        if (True):
        #if (self.live):
	    if(self.running):
                #I = self.live.takePicture();
                I = self.cam.getImage();
		#help(I);
		if (self.shouldTrack and not(self.tracking)):
		    self.tracking = True;
		    #print "Should track";
		    mapImage = self.imageCalibration.calculateImageMap("Calibration Image", I);
		    self.photos[1].setImage(mapImage);
		    # passed in from constructor
		    annImage = self.getAnnotatedImage();
		    #point = self.imageCalibration.centerOfMass;
		   ## findCenterOfMass(mapImage, (self.targetWidth, self.targetHeight));
		    # annImage.paste((125,0,0), (point[0] - int(self.targetWidth/2), point[1], point[0] + int(self.targetWidth/2), point[1]+1));
		    # annImage.paste((125,0,0), (point[0], point[1]-int(self.targetHeight/2), point[0]+1, point[1]+int(self.targetHeight/2)));
		    bigImage  = ImageOps.fit(annImage, (2*annImage.size[0], 2*annImage.size[1])); 
		    pImage = ImageTk.PhotoImage(bigImage);
		    self.trackLabel["image"] = pImage;
		    self.trackLabel.image = pImage;
		    self.tracking = False;

class PhotoUI:
    def __init__(self, tk, title, camera, imageCalibration, keepStats=False):
        self.cam = camera;
	self.imageCalibration = imageCalibration;
        self.f = Frame(tk);
        self.caption = Label(self.f, text=title);
	self.caption.pack();
        self.imageLabel = Label(self.f, text="placeholder");
	self.imageLabel.pack();
	self.keepStats = keepStats;
        self.takePicture();
        b = Button(self.f, text="Take Picture", command=self.takePicture);
        b.pack();
	self.f.pack(side="left");
        

    def takePicture(self):
        image = self.cam.getImage();   
	self.setImage(image);
	return image;

    def setImage(self, image):
        self.pimage = ImageTk.PhotoImage(image);
        self.imageLabel.image = self.pimage;
        self.imageLabel["image"] = self.pimage;
	self.imageCalibration.setImage(self.caption.cget("text"), image, self.keepStats);
	return image;

    def getFrame(self):
        return self.f;


        
class LiveUI (PhotoUI):
    def __init__(self, tk, title, camera, imageCalibration, label):
	self.best = label;
	PhotoUI.__init__(self, tk, title, camera, imageCalibration);

    def takePicture(self):
        image = PhotoUI.takePicture(self);
	self.imageCalibration.removeImage(self.caption.cget("text"));
	#findBest;
	return (image);

    def findBest(self):
        if (self.best):
	    bestName = self.imageCalibration.getBestMatch(image);
            self.best["text"] = "Best match: " + bestName;

